﻿versionname = Estelles Apropos Utility 0.5
#Include JSON.ahk
FileEncoding, utf-8
#singleinstance ignore
SetBatchLines, -1
Process, Priority,, High
SetWorkingDir %A_ScriptDir%
Menu, Tray, Icon , apropos.ico
; Use elevated rights, to bypass some possible issues with windows UAC.
IniRead, Runasadmin, settings.ini, settings, Runasadmin, 0
if(Runasadmin){
	Loop, %0%  ; For each parameter:
	{
		param := %A_Index%  ; Fetch the contents of the variable whose name is contained in A_Index.
		params .= A_Space . param
	}
ShellExecute := A_IsUnicode ? "shell32\ShellExecute":"shell32\ShellExecuteA"

If not A_IsAdmin
	{
		If A_IsCompiled
			DllCall(ShellExecute, uint, 0, str, "RunAs", str, A_ScriptFullPath, str, params , str, A_WorkingDir, int, 1)
		Else
			DllCall(ShellExecute, uint, 0, str, "RunAs", str, A_AhkPath, str, """" . A_ScriptFullPath . """" . A_Space . params, str, A_WorkingDir, int, 1)
		ExitApp
	}
}


global person = 2
global playername:=""
global descriptionfilebase := ""
global ffscene := 0
global mast := 0
global scene2 := 0
; define globals
global voicevolume:= 30
global tokenregex2 := "xx"
global blacklist := "xx"
global unnamednpcs := "xx"
global sentencerefs := ""
global searchfiles := 0
global apropos_db := ""
global notepad_path := ""
global override := 1
global overridetype := 0
global Xsays := 0
L:=0
global WTANAL :=""
global WTORAL :=""
global WTVAGINAL :=""

global wt := ""

; read bindings
IniRead, voice, settings.ini, bindings, voice, ~^+v
IniRead, voicesettings, settings.ini, bindings, voicesettings, ~^+b
IniRead, reload, settings.ini, bindings, reload, ~^+r
IniRead, Runtest, settings.ini, bindings, Runtest, ~^!t
IniRead, Toggleoverlay, settings.ini, bindings, Toggleoverlay, ~^+t
IniRead, openinnotepad, settings.ini, bindings, openinnotepad, ~^+o
IniRead, volumeup, settings.ini, bindings, volumeup, ~^+=
IniRead, volumedown, settings.ini, bindings, volumedown, ~^+-
IniRead, quickMenu, settings.ini, bindings, quickMenu, ~^!o
IniRead, editlastline, settings.ini, bindings, editlastline, ^+e

;read settings
IniRead, ffon, settings.ini, settings, enableFF, 1
IniRead, person, settings.ini, settings, perspective, 1
IniRead, playername, settings.ini, settings, playername, 
IniRead, updatespeed, settings.ini, settings, updatespeed, 100
IniRead, showtime, settings.ini, settings, showtime, 60
IniRead, overlay, settings.ini, settings, textoverlay, 1
IniRead, voiceon, settings.ini, settings, voiceon, 0
IniRead, voicevolume, settings.ini, settings, voicevolume, 30

IniRead, override, settings.ini, settings, override, 1
IniRead, overridetype, settings.ini, settings, overridetype, 2

IniRead, logpath, settings.ini, settings, logpath, C:\Users\E\Documents\My Games\Skyrim\Logs\Script\User\Apropos.0.log
filepath = %logpath%
IniRead, textopacity, settings.ini, settings, textopacity, 255
IniRead, textsize, settings.ini, settings, textsize, 20
IniRead, textColor, settings.ini, settings, textColor, White
IniRead, shadowColor, settings.ini, settings, shadowColor, 000000
IniRead, font, settings.ini, settings, font, Verdana
IniRead, fontweight, settings.ini, settings, fontweight, 400
IniRead, shadowdistance, settings.ini, settings, shadowdistance, 2

IniRead, fadingtext, settings.ini, settings, fadingtext, 1
IniRead, fadeinspeed, settings.ini, settings, fadeinspeed, 90
IniRead, fadeoutspeed, settings.ini, settings, fadeoutspeed, 30

IniRead, x_pos, settings.ini, settings, x_pos, 0
IniRead, y_pos, settings.ini, settings, y_pos, 0
IniRead, text_width, settings.ini, settings, text_width, 1600
IniRead, text_align, settings.ini, settings, text_align, Center
IniRead, searchfiles, settings.ini, settings, searchfiles, 0
IniRead, apropos_db, settings.ini, settings, apropos_db, C:\Games\Skyrim\Data\Apropos\db
IniRead, notepad_path, settings.ini, settings, notepad_path, C:\Program Files (x86)\Notepad++\notepad++.exe
IniRead, blacklist, settings.ini, settings, blacklist, Values|Synonyms|Initializing|Arousal|Token|Initializing|Apropos|^----|nimation|Actors|]:|Tear =|wear and tear|reduction amount :|Found|Log Closed|lost .* virginity|^[123] .+\w$|tracking now|NPC W|^Stage \d
IniRead, unnamednpcs, settings.ini, settings, unnamednpcs, [tT]halmor|[bB]andit|[hH]agra|[cC]ourier|\w*?\s[hH]old [gG]uard|\w*?\s[gG]uard|[hH]unter|[fF]isher|[nN]oble|[sS]tormcloak|[vV]igilant|[iI]mperial|[aA]fflicted|[dD]remora|[fF]orsworn|[hH]ired|[lL]owlife|[sS]ellsword|[vV]agrant|\w*?\s[vV]ampire |\w*?\s[cC]onjurer|\w*?\s[nN]ecromancer|\w*?\s[wW]arlock|[dD]ragon|[dD]awnguard|[cC]ultist|[Dd]og

IniRead, femVoiceName, settings.ini, settings, voicefemale, Microsoft Zira Desktop
IniRead, maleVoiceName, settings.ini, settings, voicemale, Microsoft David Desktop
IniRead, narVoiceName, settings.ini, settings, voicenarrator, Microsoft Hazel Desktop
IniRead, femVoiceRate, settings.ini, settings, femalevoicerate, 0
IniRead, femVoicePitch, settings.ini, settings, femalevoicepitch, 0
IniRead, maleVoiceRate, settings.ini, settings, malevoicerate, 0
IniRead, maleVoicePitch, settings.ini, settings, malevoicepitch, 0
IniRead, narVoiceRate, settings.ini, settings, narratorvoicerate, 0
IniRead, narVoicePitch, settings.ini, settings, narratorvoicepitch, 0
IniRead, femVoiceBoost, settings.ini, settings, femalevoiceboost, 0
IniRead, maleVoiceBoost, settings.ini, settings, malevoiceboost, 0
IniRead, narVoiceBoost, settings.ini, settings, narratorvoiceboost, 0
IniRead, Xsays, settings.ini, settings, Xsays, 1
IniRead, femvoiceposition, settings.ini, settings, femvoiceposition, 1
IniRead, malevoiceposition, settings.ini, settings, malevoiceposition, 1
IniRead, narratorvoiceposition, settings.ini, settings, narratorvoiceposition, 1

IniRead, showquickMenu, settings.ini, settings, showquickMenu, 0

;read wtstates
FileRead, wt, %apropos_db%\WearAndTear_Descriptors.txt
wt=(%wt%)

femVoiceVolume := voicevolume + femVoiceBoost
maleVoiceVolume := voicevolume + maleVoiceBoost
narVoiceVolume := voicevolume + narVoiceBoost

;init voices
femaleVoice := TTS_CreateVoice(femVoiceName, femVoiceRate, femVoiceVolume, femVoicePitch)
sleep 100
maleVoice := TTS_CreateVoice(maleVoiceName, maleVoiceRate, maleVoiceVolume, maleVoicePitch)
sleep 100
narVoice := TTS_CreateVoice(narVoiceName, narVoiceRate, narVoiceVolume, narVoicePitch)

; init tray menu
;Menu, Tray, NoStandard
Menu, Tray, Tip, %versionname%
Menu, Tray, Add, %versionname%, openinnotepad
Menu, tray, add
Menu, tray, add
Menu, tray, add, View history, openinnotepad
Menu, tray, add, Validate DB files, jsonvalid
Menu, tray, add
Menu, tray, add, Overlay, toggleoverlay
Menu, tray, add
Menu, tray, add, Voice, voiceon
Menu, tray, add, Voice Settings, voicesets
Menu, tray, add
if(showquickMenu){
Menu, tray, add, quick Menu, openothers
}
Menu, tray, add, Settings.ini, opensettings
Menu, tray, add
Menu, Tray, Add, reload, reload
Menu, Tray, Add, E&xit, tExit
Menu Tray, Disable, %versionname%
Menu Tray, Default, %versionname%  ; Set to Default
Menu Tray, Click, 1           ; Enable Single Click action on tray

If voiceon= 1
	Menu, tray, Check, Voice

If overlay= 1
	Menu, tray, Check, Overlay
	
HotKey, %editlastline%, openlastline
HotKey, %voice%, voiceon
HotKey, %voicesettings%, voicesets
HotKey, %reload%, reload
HotKey, %runtest%, runtest
HotKey, %openinnotepad%, openinnotepad
HotKey, %toggleoverlay%, toggleoverlay
HotKey, %volumeup%, volumeup
HotKey, %volumedown%, volumedown
if(showquickMenu){
HotKey, %quickMenu%, openothers
}

CustomColor = 010101 ; Can be any RGB Color (it will be made Transparent below).
Gui +LastFound +AlwaysOnTop -Caption +ToolWindow  ; +ToolWindow avoids a taskbar Button and an alt-tab Menu item.
Gui, Color, %CustomColor%
Gui, Font, s%textsize%, %font%, w%fontweight% ; Set a large font size (22-point).
Gui, Add, Text, x%shadowdistance% y%shadowdistance% w%text_width% R4 vMyText2 c%shadowColor% %text_align%, --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------  ; --- serve to auto-size the window.
Gui, Add, Text, x0 y0 w%text_width% R4 vMyText c%textColor% BackgRoundTrans %text_align%, --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------  ; --- serve to auto-size the window.

WinSet, TransColor, %CustomColor% %textopacity%
Gosub, removel  ; Make the First update immediate rather than waiting for the timer.
Gui, Show, x%x_pos% y%y_pos% AutoSize NoActivate, AproposText  ; NoActivate avoids deactivating the currently active window.
WinSet, AlwaysOnTop, On, AproposText
WinSet, AlwaysOnTop, Off, AproposText

gosub, openinnotepad

;read the last line of the apropos log
Loop Read, %filepath%
	prefL = %A_LoopReadLine%

oldsize:= 0
;start update timer
settimer, Check_file, %updatespeed% ; 5 times a second

return

~!f12::
	WinActivate, AproposText
	sleep 1
	Send !+{F12}
	WinActivate, Skyrim
return


centertext:
Screen_X = %A_ScreenWidth%
text_width  := Screen_X -(30 + 2*x_pos)
WinSet, TransColor, %CustomColor% %textopacity%, AproposText
GuiControl, MoveDraw, MyText2, % "x" shadowdistance "y" shadowdistance "w" text_width "c" shadowColor
GuiControl, MoveDraw, MyText, % "x" 0 "y" 0 "w" text_width "c" textColor
IniWrite, %text_width%, settings.ini, settings, text_width
Gui, Show, x%x_pos% y%y_pos% AutoSize NoActivate, AproposText
return

jsonvalid:
err=0
i=0
obj := new JSONþ
Loop, %apropos_db%\*.txt, , 1  ; Recurse into subfolders.
{
	fileread,json, %A_LoopFileFullPath%
	i+=1
	try{
		obj.parse(json)
		json=
	}catch e{
		err+=1
		json=
		MsgBox, 0x103,Incorrectly formatted json file, % e.Message "`nin: " A_LoopFileFullPath "`t`t`t`t`t`nwould you like to edit the file?"
			IfMsgBox, No
			{
				continue  ; User pressed the "No" button.
			}IfMsgBox, Cancel
			{
				break  ; User pressed the "Cancel" button.
			}else
				Run, %notepad_path% "%A_LoopFileFullPath%"
		sleep 300
	}
}
obj=
json=
msgbox, Done, %i% files parsed, %err% errors found!
sleep 1
Reload
return

WT-descriptions:
	Run, "%notepad_path%" "%apropos_db%\WearAndTear_Descriptors.txt"
return

Synomyms:
	Run, "%notepad_path%" "%apropos_db%\Synonyms.txt"
return

openlog:
	Run, "%notepad_path%" %logpath%
return

opensettings:
	Run, "%notepad_path%" settings.ini
return

voicesets:
	Run, Text to Speech.lnk
return

openothers:
	Run, quickmenu.ahk
return

; move text
^+Up::
	WinGetPos, X, Y, Width, Height, AproposText
	y_pos := Y-10
	Winmove, AproposText, , X, y_pos
	IniWrite, %y_pos%, settings.ini, settings, y_pos
	gosub, centertext
return
^+Down::
	WinGetPos, X, Y, Width, Height, AproposText
	y_pos := Y+10
	Winmove, AproposText, , X, y_pos
	IniWrite, %y_pos%, settings.ini, settings, y_pos
	gosub, centertext
return
^+Left::
	WinGetPos, X, Y, Width, Height, AproposText
	x_pos := X-10
	Winmove, AproposText, , x_pos, Y
	IniWrite, %x_pos%, settings.ini, settings, x_pos
	gosub, centertext
return
^+Right::
	WinGetPos, X, Y, Width, Height, AproposText
	x_pos := X+10
	Winmove, AproposText, , x_pos, Y
	IniWrite, %x_pos%, settings.ini, settings, x_pos
	gosub, centertext
return

; font size adjust
^!+Up::
	textsize := textsize+1
	IniWrite, %textsize%, settings.ini, settings, textsize
	Gui, Font, % "s" textsize  "c" textColor
	GuiControl, Font, MyText
	Gui, Font, % "s" textsize  "c" shadowColor
	GuiControl, Font, MyText2

	gosub, centertext
return

^!+Down::
	textsize := textsize-1
	IniWrite, %textsize%, settings.ini, settings, textsize
	Gui, Font, % "s" textsize  "c" textColor
	GuiControl, Font, MyText
	Gui, Font, % "s" textsize  "c" shadowColor
	GuiControl, Font, MyText2
	gosub, centertext
return

^!+Left::
	if (textopacity>8) {
		textopacity := textopacity-8
	}else{
		textopacity := 0
	}
	IniWrite, %textopacity%, settings.ini, settings, textopacity
	gosub, centertext
return

^!+Right::
	if (textopacity < 247) {
		textopacity := textopacity+8
	}else{
		textopacity := 255
	}
	IniWrite, %textopacity%, settings.ini, settings, textopacity
	gosub, centertext
return

; check logfile for changes and call main function if changed
check_file:
	;open file to get filesize updates
	FileOpen(filepath, "r")
	FileGetSize, newsize, %filepath%
	If ( newsize != oldsize)
	{
		Gosub, readfile
		oldsize:= newsize
	}
return


L3:=""
L4:=""
L5:=""
L6:=""

;main fuction
readfile:
	Loop Read, %filepath%
	{
		L6 := L5
		L5 := L4
		L4 := L3
		L3 := tokL
		tokL := L2
		L2 := L
		L = %A_LoopReadLine%
	}
	If (L = prefL){
		;no change
		return
	}Else{
		prefL := L
		gendFem :=1
		descriptionfile := checkFF(L,L2,tokL,L3,L4,L5,L6,active)
		if (descriptionfile && ffon){
			;msgbox, %descriptionfile%,%active%
			L := getdescription(descriptionfile,active,gendFem,narrsent,oriStrLen)
		}else{
			; use filter to see if line is valid
			L := filter(L,tokL,L2,gendFem,narrsent,oriStrLen)
		}
		If (L != "none"){
			If (textReady == 0){
				; wait for removel timer it text is being shown.
				while(textReady==0){
					sleep 100
				}
			}
			;remove previous text
			Gosub, removel
			sleep 100
			If (overlay=1){
			
				If (fadingtext!=0){
					fadeopacity := 0
					WinSet, TransColor, %CustomColor% %fadeopacity%, AproposText
					settimer, fadein, 2
				}
				
				;shows texts
				GuiControl, 1:, MyText2, %L%
				GuiControl, 1:, MyText, %L%
				WinSet, AlwaysOnTop, On, AproposText
				WinSet, Top,, AproposText
				WinSet,Redraw,, AproposText
				WinActivate, ahk_exe TESV.exe

			}
			If (voiceon= 1){
				Say(L,gendFem,narrsent)
			}
			textReady:= 0
			;calculate time from text lenght
			llen := -1 *(( showtime * oriStrLen) + 1000)
			settimer, removel, %llen%
		}
	}
return

; FF attempt
checkFF(L,L2,L3,L4,L5,L6,L7,byref active){
	FoundPos := RegExMatch(L, "\[.+?] (.*)", Ltex)
	If (FoundPos > 0){
		RegExMatch(L2, "\[.+?] (.*)", L2tex)
		RegExMatch(L3, "\[.+?] (.*)", L3tex)
		RegExMatch(L4, "\[.+?] (.*)", L4tex)
		RegExMatch(L5, "\[.+?] (.*)", L5tex)
		
		; detect WT states
		wt_match=%playername%: (.*) Wear & Tear = .* \(value\) (.) \(state\)
		wtstage := RegExMatch(Ltex1, wt_match, WTmatches1_)
		if(wtstage > 0){
			RegExMatch(L2tex1, wt_match, WTmatches2_)
			RegExMatch(L3tex1, wt_match, WTmatches3_)
			;msgbox, |%WTmatches1_1%|  |%WTmatches2_1%|  |%WTmatches3_1%|
			loop, 3{
				level=% WTmatches%A_Index%_2
				wtvar = descriptors.level%level%
				wtdescr := random(wt,wtvar)
				if (WTmatches%A_Index%_1=="Anal"){
					;msgbox, anal
					WTANAL = %wtdescr%
				}else if (WTmatches%A_Index%_1=="Vaginal"){
					;msgbox, vag
					WTVAGINAL = %wtdescr%
				}else if (WTmatches%A_Index%_1=="Oral"){
					;msgbox, oral
					WTORAL = %wtdescr%
				}
			}
		}
		
		;detect firststage of animation
		firststage := RegExMatch(L, "\[.+?] ---- StageStart ---- Stage: 1", Lfirst)
		If (firststage > 0){
			switch := RegExMatch(L2, "\[.+?] ---- StageEnd ---- Stage: 1", L2switch)
			; if first stage of first scene
			if(switch <= 0){
				scene2:=0
				RegExMatch(L2tex1, "\((.*)\)", animtags)
				RegExMatch(L3tex1, "\[(.)]: (.+), (.+?)\b( \(Victim\))*", actor1_)
				RegExMatch(L4tex1, "\[(.)]: (.+), (.+?)\b( \(Victim\))*", actor2_)
				RegExMatch(L5tex1, "\[(.)]: (.+), (.+?)\b( \(Victim\))*", actor3_)
				mast:=0
				;is it a masturabtion scene with the actor in it?
				IfInString, animtags1, Masturbation
					mast := 1
				if(mast){
					;msgbox, its a masturbation scene
					if(actor1_2=playername && actor1_3=="female"){
						;msgbox, its a masturbation scene with female player
						descriptionfilebase = FemaleActor/FemaleActor_Masturbation
						descriptionfile = %descriptionfilebase%.txt
						ffscene :=1
					}else if(actor1_2=playername && actor1_3=="male"){
						descriptionfilebase = MaleActor/MaleActor_Masturbation
						descriptionfile = %descriptionfilebase%.txt
						ffscene :=1
					}else{
					;msgbox, its a masturbation scene no female player
					}
				}
				
				
				;is it a ff scene with the actor in it?
				if(mast != 1 && actor2_3=="female" && actor1_3=="female"){
					ffscene :=1
					;msgbox, %ffscene%
					if(actor2_1=1 && actor2_2=playername){
						dom := 1
						active := actor1_2
					}else if(actor1_1=1 && actor1_2=playername) {
						dom := 1
						active := actor2_2
					}else if(actor1_1=0) {
						dom := 0
						active := actor2_2
					}else {
						dom := 0
						active := actor1_2
					}
					if(actor1_4>"" || actor2_4>"") {
						rape := "_Rape"
					}else{
						rape := ""
					}
					; find animtype
					IfInString, animtags1, Foreplay
						type = Foreplay
					IfInString, animtags1, BoobJob
						type = BoobJob
					IfInString, animtags1, HandJob
						type = Handjob
					IfInString, animtags1, FootJob
						type = Footjob
					IfInString, animtags1, Anal
						type = Anal
					IfInString, animtags1, Vaginal
						type = Vaginal
					IfInString, animtags1, Oral
						type = Oral
					IfInString, animtags1, Fisting
						type = Fisting

					typeFF = _
					IfInString, animtags1, FF
						typeFF = _FF_

					if dom=1
						domdir=_Dom\
					else
						domdir=\
					descriptionfilebase = FemaleActor_Female%domdir%FemaleActor_Female%typeFF%%type%%rape%
					descriptionfile = %descriptionfilebase%.txt
				}else{
					if(mast != 1 && (actor1_2=playername || actor2_2=playername) ){
						ffscene:=0
						scene2:=0
					}else{
						;scene2:=0
					}
				}
			}else{
				;if first stage of second scene
				scene2:=1
				;descriptionfile = %descriptionfilebase%.txt
			}
		}else if (ffscene = 1) {
			stage := RegExMatch(L, "\[.+?] ---- StageStart ---- Stage: (.)", stage_)
			If (stage>0){
				if(scene2!=1){ 		;if not second scene
					stagenum := stage_1
					descriptionfile = %descriptionfilebase%_Stage%stagenum%.txt
				}
			}else{
				orgasm := RegExMatch(L, "Animation:.+?\((.*)\)", animtags)
				If (orgasm>0){
					;msgbox, %mast% is on off.
					if(mast != 1){ ;dont reread actors for masturbation
						IfInString, animtags1, Foreplay
							type = Foreplay
						IfInString, animtags1, BoobJob
							type = BoobJob
						IfInString, animtags1, HandJob
							type = Handjob
						IfInString, animtags1, FootJob
							type = Footjob
						IfInString, animtags1, Anal
							type = Anal
						IfInString, animtags1, Vaginal
							type = Vaginal
						IfInString, animtags1, Oral
							type = Oral
						IfInString, animtags1, Fisting
							type = Fisting
						typeFF = _
						IfInString, animtags1, FF
							typeFF = _FF_
						
						RegExMatch(L2tex1, "\[(.)]: (.+), (.+?)\b( \(Victim\))*", actor1_)
						RegExMatch(L3tex1, "\[(.)]: (.+), (.+?)\b( \(Victim\))*", actor2_)
						if(actor2_1=1 && actor2_2=playername){
							dom := 1
							active := actor1_2
						}else if(actor1_1=1 && actor1_2=playername) {
							dom := 1
							active := actor2_2
						}else if(actor1_1=0) {
							dom := 0
							active := actor2_2
						}else{
							dom := 0
							active := actor1_2
						}
						if(actor1_4>"" || actor2_4>"") {
							rape := "_Rape"
						}else{
							rape := ""
						}
						if dom=1
							domdir=_Dom\
						else
							domdir=\
						
						descriptionfilebase = FemaleActor_Female%domdir%FemaleActor_Female%typeFF%%type%%rape%
					}
					;if not second scene
					descriptionfile = %descriptionfilebase%_Orgasm.txt
					preffscene :=1
					scene2:=0
				}
			}
		}
	}
	if ffscene{
		if (preffscene){
			preffscene :=0
			ffscene :=0
			mast:=0
		}
		return descriptionfile
	}else{
		return false
	}
}

getdescription(descriptionfile,active,byref gendFem,byref narrstr,byref oriStrLen){
	;read description file
	FileRead, Contents, %apropos_db%\%descriptionfile%
	if not ErrorLevel  ; Successfully loaded.
	{
		StringReplace,Contents,Contents,`n,,A
		StringReplace,Contents,Contents,`r,,A
		;read right perspective
		if(person=1)
			RegExMatch(Contents, """(1.+?)"".*?:.*?\[(.*?)\]", linelist1_)
		else if person=2
			RegExMatch(Contents, """(2.+?)"".*?:.*?\[(.*?)\]", linelist1_)
		else
			RegExMatch(Contents, """(3.+?)"".*?:.*?\[(.*?)\]", linelist1_)
		Contents =  ; Free the memory.
		;msgbox, %linelist1_2%
		StringReplace, linelist1_2, linelist1_2, "`,, *, All
		StringSplit, linearray1_,linelist1_2,*,%A_Space%%A_Tab%"
		;get random line
		Random, randomnum , 1, %linearray1_0%
		randomline = % linearray1_%randomnum%
		;msgbox, %linearray1_0% items,  %randomnum% item = %randomline%
		regexsentence := RegExReplace(randomline, "({ACTIVE}|{PRIMARY})" ,".*?")
		StringReplace,randomline,randomline,{ACTIVE},%active%,A
		StringReplace,randomline,randomline,{PRIMARY},%playername%,A
		start := (matched := 0) + 1
		;read synonym placeholders
		loop
			if regexmatch(randomline,"(?<whole>.*?(?<ANSWER" . a_index . ">{.+?}))",The_,start) and ++matched
				start += strlen(The_whole) 
			else
				break
		;msgbox, %randomline%
		;MSGBOX, %regexsentence%
		
		StringReplace,regexsentence,regexsentence,;,:,A
		;replace synonym placeholders
		;randomline := RegExReplace(randomline, "( {WTVAGINAL}| {WTANAL}| {WTORAL})" ,"")
		;read synonyms
		FileRead, j, %apropos_db%\Synonyms.txt
		j= (%j%)
		loop % matched{
			syn_sign =% The_Answer%A_index%
			;random selection from synonyms file.
			replacevalue :=random(j,syn_sign)
			if (replacevalue <= 0){
				StringReplace,syn_sign2,syn_sign,{,,A
				StringReplace,syn_sign2,syn_sign2,},,A
				replacevalue := % %syn_sign2%
				;msgbox, %replacevalue%
				}
			;msgbox %syn_sign% %replacevalue%
			StringReplace,regexsentence,regexsentence,%syn_sign%,.*?,A
			StringReplace,randomline,randomline,%syn_sign%,%replacevalue%,A
			}
		;MSGBOX, %regexsentence%
		;msgbox, %randomline%
		; add The to unnamed npcs
		unnamednpclist =(%unnamednpcs%)
		Lf1 := RegExReplace(randomline,unnamednpclist,"the $1")
		the_unnamednpclist = ^(\()?the %unnamednpclist%
		Lf1 := RegExReplace(Lf1, the_unnamednpclist,"$1The $2")
		oriStrLen := StrLen(Lf1)
		
		If (searchfiles){
			;further regex formatting for filesearch
			regexsentence := RegExReplace(regexsentence, "\\" ,"\\")
			regexsentence := RegExReplace(regexsentence, "\(" ,"\(")
			regexsentence := RegExReplace(regexsentence, "\)" ,"\)")
			regexsentence := RegExReplace(regexsentence, "\." ,"\.")
			regexsentence := RegExReplace(regexsentence, "\^" ,"\^")
			regexsentence := RegExReplace(regexsentence, "\$" ,"\$")
			regexsentence := RegExReplace(regexsentence, "\*" ,"\*")
			regexsentence := RegExReplace(regexsentence, "\+" ,"\+")
			regexsentence := RegExReplace(regexsentence, "\?" ,"\?")
			regexsentence := RegExReplace(regexsentence, "\|" ,"\|")
			regexsentence := RegExReplace(regexsentence, "\{" ,"\{")
			regexsentence := RegExReplace(regexsentence, "\}" ,"\}")
			regexsentence := RegExReplace(regexsentence, "\[" ,"\[")
			regexsentence := RegExReplace(regexsentence, "\]" ,"\]")
			regexsentence := RegExReplace(regexsentence, "\\\.\\\*\\\?" ,".*")
			;MSGBOX, %regexsentence%
			searchcommand = findstr /spinmrc:"%regexsentence%" "%apropos_db%\*"
			searchcommand = %comspec% /c %searchcommand% | clip
			;msgbox, %searchcommand%
			ClipSaved := ClipboardAll
			;msgbox, %searchcommand%
			RunWaitTimeout(searchcommand,7,,"Hide") ;Hidden
			sentencefile := Clipboard
			clipboard := ClipSaved
			ClipSaved =
			;msgbox, %sentencefile%
			StringTrimLeft, sentencefile, sentencefile, 0
			StringTrimRight, sentencefile, sentencefile, 2
			sentencerefs := sentencefile
			FilePathhist = Apropos_util_history.txt
			StringReplace,sentencefile,sentencefile,`n,,A
			StringReplace,sentencefile,sentencefile,`r,?, A UseErrorLevel
			nrfound := ErrorLevel
			mlen := StrLen(sentencefile)
			if(mlen > 1){
				nrfound := nrfound +1
			}else{
				nrfound = 0
			}
			;add new line to history
			oriStrLen := StrLen(Lf1)
			paddedStr := Lf1
			Length := 190- oriStrLen
			Loop, % Length
				paddedStr .= Chr(32)
			newline = [%nrfound%] %paddedStr%;%regexsentence%;%sentencefile%`n
			FilePrepend(FilePathhist, newline)
			sleep 10
			Gosub, Refresh
		}
	}Else{
		Lf1 := "none"
	}
	spoken := RegExMatch(Lf1, "(^\(.*\))", who)
	if(spoken > 0){
		you := RegExMatch(who1, "You")
		if(you  > 0){
			gendFem := 1
		}Else{
			gendFem := -1
		}
		RegExMatch(Lf1, "(^\(.*\))(.+)", narrsent)
		Lf1 := narrsent2
		narrstr := narrsent1
	}Else{
		gendFem:=-1
	}
return Lf1
}

random(j,syn_sign){
	replacevalues = % json(j,syn_sign)
	StringReplace,replacevalues,replacevalues,`n,,A
	StringReplace,replacevalues,replacevalues,`r,,A
	StringReplace, replacevalues, replacevalues, "`,,*, All
	StringSplit, replacevalue_,replacevalues,*,%A_Space%%A_Tab%"][
	Random, randomnum , 1, %replacevalue_0%
	x :=% replacevalue_%randomnum%
	return x
}

json(ByRef js, s, v = "") {
	j = %js%
	Loop, Parse, s, .
	{
		p = 2
		RegExMatch(A_LoopField, "([+\-]?)([^[]+)((?:\[\d+\])*)", q)
		Loop {
			If (!p := RegExMatch(j, "(?<!\\)(""|')([^\1]+?)(?<!\\)(?-1)\s*:\s*((\{(?:[^{}]++|(?-1))*\})|(\[(?:[^[\]]++|(?-1))*\])|"
				. "(?<!\\)(""|')[^\7]*?(?<!\\)(?-1)|[+\-]?\d+(?:\.\d*)?|true|false|null?)\s*(?:,|$|\})", x, p))
				Return
			Else If (x2 == q2 or q2 == "*") {
				j = %x3%
				z += p + StrLen(x2) - 2
				If (q3 != "" and InStr(j, "[") == 1) {
					StringTrimRight, q3, q3, 1
					Loop, Parse, q3, ], [
					{
						z += 1 + RegExMatch(SubStr(j, 2, -1), "^(?:\s*((\[(?:[^[\]]++|(?-1))*\])|(\{(?:[^{\}]++|(?-1))*\})|[^,]*?)\s*(?:,|$)){" . SubStr(A_LoopField, 1) + 1 . "}", x)
						j = %x1%
					}
				}
				Break
			}
			Else p += StrLen(x)
		}
	}
	If v !=
	{
		vs = "
		;"
		If (RegExMatch(v, "^\s*(?:""|')*\s*([+\-]?\d+(?:\.\d*)?|true|false|null?)\s*(?:""|')*\s*$", vx)
			and (vx1 + 0 or vx1 == 0 or vx1 == "true" or vx1 == "false" or vx1 == "null" or vx1 == "nul"))
			vs := "", v := vx1
		StringReplace, v, v, ", \", All
		js := SubStr(js, 1, z := RegExMatch(js, ":\s*", zx, z) + StrLen(zx) - 1) . vs . v . vs . SubStr(js, z + StrLen(x3) + 1)
	}
	Return, j == "false" ? 0 : j == "true" ? 1 : j == "null" or j == "nul"
		? "" : SubStr(j, 1, 1) == """" ? SubStr(j, 2, -1) : j
}

;filters the logfile contents
filter(L,tokL,L2,byref gendFem,byref narrstr,byref oriStrLen){
	FoundPos := RegExMatch(L, "\[.+?] (.*)", Lf)
	If (FoundPos > 0){
		blacklistlist = (%blacklist%)
		blacklistr := RegExMatch(Lf1, blacklistlist)
		If (blacklistr > 0){
			Lf1 := "none"
		}Else If (searchfiles){
			FoundPos2 := RegExMatch(tokL, "\[.+?] (.*)", tokLf)
			FoundPos3 := RegExMatch(L2, "\[.+?] (.*)", tokL2f)
			tokenloc := RegExMatch(tokLf1, "TokenValues : (.*)", tokens)
			tokenloc2 := RegExMatch(tokL2f1, "TokenValues : (.*)", tokens2)
			if(tokenloc > 0){
				tokenregex := RegExReplace(tokens1, "," ,"|")
				go:=1
			}Else If (tokenloc2 > 0){
				tokenregex := RegExReplace(tokens21, "," ,"|")
				go:=1
			}Else{
				go:=0
			}
			if(go){
				Sort, tokenregex, D| F SortFunc
				tokenregex2 = (%tokenregex%)
				;lots of shit to find the original file in the database
				regexsentence := RegExReplace(Lf1, tokenregex2 ,".*?")
				regexsentence := RegExReplace(regexsentence, "\\" ,"\\")
				regexsentence := RegExReplace(regexsentence, "\(" ,"\(")
				regexsentence := RegExReplace(regexsentence, "\)" ,"\)")
				regexsentence := RegExReplace(regexsentence, "\." ,"\.")
				regexsentence := RegExReplace(regexsentence, "\^" ,"\^")
				regexsentence := RegExReplace(regexsentence, "\$" ,"\$")
				regexsentence := RegExReplace(regexsentence, "\*" ,"\*")
				regexsentence := RegExReplace(regexsentence, "\+" ,"\+")
				regexsentence := RegExReplace(regexsentence, "\?" ,"\?")
				regexsentence := RegExReplace(regexsentence, "\|" ,"\|")
				regexsentence := RegExReplace(regexsentence, "\{" ,"\{")
				regexsentence := RegExReplace(regexsentence, "\}" ,"\}")
				regexsentence := RegExReplace(regexsentence, "\[" ,"\[")
				regexsentence := RegExReplace(regexsentence, "\]" ,"\]")
				regexsentence := RegExReplace(regexsentence, "\\\.\\\*\\\?" ,".*")

				searchcommand = findstr /spinmrc:"%regexsentence%" "%apropos_db%\*"
				searchcommand = %comspec% /c %searchcommand% | clip
				;msgbox, %searchcommand%
				ClipSaved := ClipboardAll
				RunWaitTimeout(searchcommand,7,,"Hide") ;Hidden
				;msgbox, IT IS ON!!!!!!!
				sentencefile := Clipboard
				clipboard := ClipSaved
				ClipSaved =
				;msgbox, %sentencefile%
				StringTrimLeft, sentencefile, sentencefile, 0
				StringTrimRight, sentencefile, sentencefile, 2
				sentencerefs := sentencefile
				FilePathhist = Apropos_util_history.txt
				StringReplace,sentencefile,sentencefile,`n,,A
				StringReplace,sentencefile,sentencefile,`r,?, A UseErrorLevel
				nrfound := ErrorLevel
				mlen := StrLen(sentencefile)
				if(mlen > 1){
					nrfound := nrfound +1
				}else{
					nrfound = 0
				}
				; add The to unnamed npcs
				unnamednpclist =(%unnamednpcs%)
				Lf1 := RegExReplace(Lf1,unnamednpclist,"the $1")
				the_unnamednpclist = ^(\()?the %unnamednpclist%
				Lf1 := RegExReplace(Lf1, the_unnamednpclist,"$1The $2")
				;add new line to history
				oriStrLen := StrLen(Lf1)
				paddedStr := Lf1
				Length := 190- oriStrLen
				Loop, % Length
					paddedStr .= Chr(32)
				newline = [%nrfound%] %paddedStr%;%regexsentence%;%sentencefile%`n
				FilePrepend(FilePathhist, newline)
				sleep 10
				Gosub, Refresh
			}
		}else{
			;just add The to unnamed npcs
			unnamednpclist =(%unnamednpcs%)
			Lf1 := RegExReplace(Lf1,unnamednpclist,"the $1")
			the_unnamednpclist = ^(\()?the %unnamednpclist%
			Lf1 := RegExReplace(Lf1, the_unnamednpclist,"$1The $2")
			;add new line to history
			oriStrLen := StrLen(Lf1)
		}
	}Else{
		Lf1 := "none"
	}
	spoken := RegExMatch(Lf1, "(^\(.*\))", who)
	if(spoken > 0){
		you := RegExMatch(who1, "(You|" . playername . ")")
		if(you  > 0){
			gendFem := 1
		}Else{
			gendFem := 0
		}
		RegExMatch(Lf1, "(^\(.*\))(.+)", narrsent)
		Lf1 := narrsent2
		narrstr := narrsent1
	}Else{
		gendFem:=-1
	}
	return Lf1
}

; ##functions:

RunWaitTimeout(Target, SecondsToWait="", WorkingDir="", MaxMinHide="") {
			  Run, %Target%, %WorkingDir%, %MaxMinHide%|UseErrorLevel, OutputVarPID
			  If (ErrorLevel) 
				Return ErrorLevel 
				timeouttime:=SecondsToWait*-950
				SetTimerF("taskkiller",timeouttime,Object(1,OutputVarPID))
				Process, WaitClose, %OutputVarPID%, %SecondsToWait%
				;sleep 6000
				;Run, taskkill /pid %OutputVarPID% /t /f
				;Process, WaitClose, findstr.exe, %SecondsToWait%
			  If (ErrorLevel) {
				Process, Close, %OutputVarPID%
				;SetTimerF("taskkiller",timeouttime,Object(1,OutputVarPID))
				Return !(ErrorLevel) 
			  } 
			  Return ErrorLevel 
			}
			
taskkiller(parPID){
	 Run, taskkill /pid %parPID% /t /f,,hide
}

SetTimerF( Function, Period=0, ParmObject=0, Priority=0 ) { 
 Static current,tmrs:=[] ;current will hold timer that is currently running
 If IsFunc( Function ) {
    if IsObject(tmr:=tmrs[Function]) ;destroy timer before creating a new one
       ret := DllCall( "KillTimer", UInt,0, PTR, tmr.tmr)
       , DllCall("GlobalFree", PTR, tmr.CBA)
       , tmrs.Remove(Function) 
    if (Period = 0 || Period = "off")
       return ret ;Return as we want to turn off timer
	 ; create object that will hold information for timer, it will be passed trough A_EventInfo when Timer is launched
    tmr:=tmrs[Function]:={func:Function,Period:Period="on" ? 250 : Period,Priority:Priority
								,OneTime:Period<0,params:IsObject(ParmObject)?ParmObject:Object()
								,Tick:A_TickCount}
    tmr.CBA := RegisterCallback(A_ThisFunc,"F",4,&tmr)
    return !!(tmr.tmr  := DllCall("SetTimer", PTR,0, PTR,0, UInt
								, (Period && Period!="On") ? Abs(Period) : (Period := 250)
								, PTR,tmr.CBA,"PTR")) ;Create Timer and return true if a timer was created
				, tmr.Tick:=A_TickCount
 }
 tmr := Object(A_EventInfo) ;A_Event holds object which contains timer information
 if IsObject(tmr) {
	 DllCall("KillTimer", PTR,0, PTR,tmr.tmr) ;deactivate timer so it does not run again while we are processing the function
	 If (current && tmr.Priority<current.priority) ;Timer with higher priority is already current so return
		 Return (tmr.tmr:=DllCall("SetTimer", PTR,0, PTR,0, UInt, 100, PTR,tmr.CBA,"PTR")) ;call timer again asap
	 current:=tmr
	 ,tmr.tick:=ErrorLevel :=Priority ;update tick to launch function on time
	 ,tmr.func(tmr.params*) ;call function
    if (tmr.OneTime) ;One time timer, deactivate and delete it
       return DllCall("GlobalFree", PTR,tmr.CBA)
				 ,tmrs.Remove(tmr.func)
	 tmr.tmr:= DllCall("SetTimer", PTR,0, PTR,0, UInt ;reset timer
				,((A_TickCount-tmr.Tick) > tmr.Period) ? 0 : (tmr.Period-(A_TickCount-tmr.Tick)), PTR,tmr.CBA,"PTR")
	 current= ;reset timer
 }
}

;sorts regex, longest first to avoid wrong substitutions.
SortFunc(lineA, lineB, offset)
	{
		; Return positive if lineA is longer than line B.
		; Return negative if lineA is shorter than line B.
		If StrLen(lineA) != StrLen(lineB)
			return StrLen(lineB)-StrLen(lineA)
		; Use offset to try to preserve the order in the file when two lines are of equal length.
		return -offset
	}

Say(Say,female,narrsent) {
		global femaleVoice
		global maleVoice
		global narVoice
		if(override=1){
		female:= overridetype-1
	}
if(female=1){
If Xsays
	narVoice.Speak(narrsent,1)
sleep 50
femaleVoice.Speak(Say,1)
sleep 1
}Else If(female=0){
	If Xsays
		narVoice.Speak(narrsent,1)
	sleep 50
	maleVoice.Speak(Say,1)
	sleep 1
}Else{
	narVoice.Speak(Say,1)
	sleep 1
}
}


FilePrepend(FilePath, Text, Encoding="") {
		oFile := FileOpen(FilePath, "a`n", Encoding ? Encoding : "")
		oFile.Tell(0)
		_temp := oFile.Read()
		oFile.Tell(0)
		oFile.Encoding := Encoding
		If oFile.Write(Text _temp)
			OK := True
		oFile.Close()
		Return OK
	}

	
; ##subroutines:
;remove text
removel:
		If (fadingtext!=0){
			settimer, fadeout, 2
		} else {
			GuiControl,1:, MyText2,
			GuiControl,1:, MyText,
			textReady:= 1
			gosub, resetontop
		}
return

fadeout:
		if  (fadeopacity>0) {
			WinSet, TransColor, %CustomColor% %fadeopacity%, AproposText
			fadeopacity -= (fadeoutspeed/10)
		} else {
			GuiControl,1:, MyText2,
			GuiControl,1:, MyText,
			textReady:= 1
			settimer, fadeout, off
			gosub, resetontop
		}
return

fadein:
		if  (fadeopacity<textopacity) {
			WinSet, TransColor, %CustomColor% %fadeopacity%, AproposText
			fadeopacity += (fadeinspeed/10)
		} else {
			settimer, fadein, off
		}
return

resetontop:
WinSet, AlwaysOnTop, Off, AproposText
WinSet, Top,, ahk_exe TESV.exe
WinActivate, ahk_exe TESV.exe
return

;test
runtest:
;msgbox, %A_FileEncoding%

	GuiControl,, MyText,
	GuiControl,, MyText2,
	sleep 300
	test1 := "Narrator Voice: This is a test to check if the text is shown, and to help with positioning."
	test2 := "Female Voice: Here are some test lines: The quick brown fox jumps over the lazy dog."
	test3 := "Male Voice: Lorum Ipsum Dolor Sit amet something something. Ok, this was the test."
	test = %test1% %test2% %test3%

	If (overlay= 1){
	
		If (fadingtext!=0){
			fadeopacity := 0
			WinSet, TransColor, %CustomColor% %fadeopacity%, AproposText
			settimer, fadein, 2
		}
		
		GuiControl,, MyText2, %test%
		GuiControl,, MyText, %test%
		WinSet, AlwaysOnTop, On, AproposText
		WinSet, Top,, AproposText
		WinSet,Redraw,, AproposText
		WinActivate, ahk_exe TESV.exe
	}
	
	If (voiceon= 1){
		Say(test1, -1,"")
		sleep 40
		Say(test2, 1,"")
		sleep 60
		Say(test3, 0,"")
	}
	
	llen := -1 *(( showtime * StrLen(test)) + 1000)
	settimer, removel, %llen%
return

voiceon:
	Suspend, Permit
	If (voiceon= 0)
	{voiceon:= 1
		Menu, tray, Check, Voice
		Say("Voice on",1,"")
		TrayTip, Voice:, on, 2, 17
		sleep 2000
		TrayTip,

	}Else
	{voiceon:= 0
		Menu, tray, UnCheck, Voice
		Say("Voice off",1,"")
		TrayTip, Voice:, off, 2, 17
		sleep 2000
		TrayTip,
	}
	IniWrite, %voiceon%, settings.ini, settings, voiceon
return

toggleoverlay:
	Suspend, Permit
	If (overlay= 0)
	{
		overlay:= 1
		Menu, tray, Check, Overlay
		Say("text overlay  on",0,"")
		TrayTip, Text overlay:, on, 2, 17
		sleep 2000
		TrayTip,
	}Else
	{overlay:= 0
		Menu, tray, UnCheck, Overlay
		Say("text overlay off",0,"")
		TrayTip, Text overlay:, off, 2, 17
		sleep 2000
		TrayTip,
	}
	IniWrite, %overlay%, settings.ini, settings, textoverlay
return

openinnotepad:
	Gui, 2:Destroy
	ListBox_Text := ""
	Loop, Read, Apropos_util_history.txt
	{
		ListBox_Text .= A_LoopReadLine "|" ;append a line of text
	}
	Gui, 2:Add, Text,, Double click a sentence to open in text editor.
	Gui, 2:Add, ListBox, vMyListBox gMyListBox w640 r12 Choose1 , %ListBox_Text%
	;Gui, 2:Add, Button, Default, OK
	Gui, 2:Add, Text,ym w100 , history:
	Gui, 2:Add, Button, gRefresh w100 , Refresh list
	Gui, 2:Add, Button,gClearhistory w100 , Clear history
	Gui, 2:Add, Text,w100 , Apropos files:
	;Gui, 2:Add, Button, gopenlog w100 , Open log file
	Gui, 2:Add, Button,gSynomyms w100 , Synomyms file
	Gui, 2:Add, Button,gWT-descriptions w100 , WT-descriptions file
	Gui, 2:Add, Button,gjsonvalid w100 , Validate DB files
	if(showquickMenu){
	Gui, 2:Add, Text,, Other files:
	Gui, 2:Add, Button, gopenothers, quick Menu
	}

Gui, 2:Add, Text,ym, voice settings:
If override
	Checked=Checked
Else
	Checked=
Gui, 2:Add, Checkbox, goverrider vvoiceoverride %Checked%, always narrator?
Voice := ComObjCreate("SAPI.SpVoice")
voices := TTS(Voice, "GetVoices")
StringReplace, voicechoises, voices, `n, |, All
Gui, 2:Add, Text,, narrator:
Gui, 2:Add, DropDownList, vnarvoicep gnarvoice AltSubmit Choose%narratorvoiceposition%,%voicechoises%
Gui, 2:Add, Text,, female:
Gui, 2:Add, DropDownList, vfemvoicep gfemvoice AltSubmit Choose%femvoiceposition%,%voicechoises%
Gui, 2:Add, Text,, male:
Gui, 2:Add, DropDownList, vmalevoicep gmalevoice AltSubmit Choose%malevoiceposition%,%voicechoises%

Gui, 2:Add, Text,ym , *FF support*
If ffon
	Checked2=Checked
Else
	Checked2=
Gui, 2:Add, Checkbox, gffmode vffon %Checked2%, enable FF support?
Gui, 2:Add, Text,, PC name:
Gui, 2:Add, Edit, R1 vPlname gChangePlname
Gui, 2:Add, Text,, Narrative mode (person):
Gui, 2:Add, DropDownList, vperson gselectpers Choose%person%, 1|2|3
GuiControl,2:,Plname, %playername%
Gui, 2:Add, Text,, other settings:
Gui, 2:Add, Button, gopensettings, open settings.ini
Gui, 2:Show, , %versionname%
return

ChangePlname:
	GuiControlGet, Plname
	IniWrite, %Plname%, settings.ini, settings, playername
	playername := Plname
return

ffmode:
	GuiControlGet, ffon
	IniWrite, %ffon%, settings.ini, settings, enableFF
	ffon := ffon
return

selectpers:
	GuiControlGet, person
	IniWrite, %person%, settings.ini, settings, perspective
	person := person
	return

overrider:
	GuiControlGet, voiceoverride
	IniWrite, %voiceoverride%, settings.ini, settings, override
	override := voiceoverride
return

getvoices:
	Voice := ComObjCreate("SAPI.SpVoice")
	MsgBox % TTS(Voice, "GetVoices")
return

femvoice:
	GuiControlGet, femvoicep
	StringSplit, word_array, voicechoises, |
	voicename = % word_array%femvoicep%
	GuiControlGet, MyListBox
	MyListBox1 := RegExReplace(MyListBox, "\[.*\](.*?);.+","$1")
	femaleVoice := TTS_CreateVoice(voicename, femVoiceRate, femVoiceVolume, femVoicePitch)
	saytext= %voicename%, %MyListBox1%
	Say(saytext, 1,"")
	femvoiceposition := femvoicep
	IniWrite, %femvoicep%, settings.ini, settings, femvoiceposition
	IniWrite, %voicename%, settings.ini, settings, voicefemale
return

malevoice:
	GuiControlGet, malevoicep
	StringSplit, word_array, voicechoises, |
	voicename = % word_array%malevoicep%
	GuiControlGet, MyListBox
	MyListBox1 := RegExReplace(MyListBox, "\[.*\](.*?);.+","$1")
	maleVoice := TTS_CreateVoice(voicename, maleVoiceRate, maleVoiceVolume, maleVoicePitch)
	saytext= %voicename%, %MyListBox1%
	Say(saytext, 0,"")
	malevoiceposition := malevoicep
	IniWrite, %malevoicep%, settings.ini, settings, malevoiceposition
	IniWrite, %voicename%, settings.ini, settings, voicemale
return

narvoice:
	GuiControlGet, narvoicep
	StringSplit, word_array, voicechoises, |
	voicename = % word_array%narvoicep%
	GuiControlGet, MyListBox
	MyListBox1 := RegExReplace(MyListBox, "\[.*\](.*?);.+","$1")
	narVoice := TTS_CreateVoice(voicename, narVoiceRate, narVoiceVolume, narVoicePitch)
	saytext= %voicename%, %MyListBox1%
	Say(saytext, -1,"")
	narratorvoiceposition := narvoicep
	;msgbox, %narvoicep%
	IniWrite, %narvoicep%, settings.ini, settings, narratorvoiceposition
	IniWrite, %voicename%, settings.ini, settings, voicenarrator
return

MyListBox:
	If A_GuiEvent <> DoubleClick
		return
	; Otherwise, the user double-clicked a list item, so treat that the same as pressing OK.
	; So fall through to the next label.
2ButtonOK:

	GuiControlGet, MyListBox , 2: ; Retrieve the ListBox's current selection.
	StringSplit, sentencefilearr, MyListBox, ";"
	filefound=0
	Gosub, Reallyopen
	If filefound = 0
		MsgBox No matches were found for this file.
return

Refresh:
	ListBox_Text := ""
	Loop, Read, Apropos_util_history.txt
	{
		ListBox_Text .= A_LoopReadLine "|" ;append a line of text
	}
	GuiControl,2:,MyListBox, |%ListBox_Text%
return

openlastline:
GuiControl, 2:Choose, MyListBox, 1
gosub,2ButtonOK
return

Clearhistory:
	msgbox,4, really Delete history?,really Delete history?
	IfMsgBox, No
Return
FileDelete,  Apropos_util_history.txt
FileAppend,,Apropos_util_history.txt
ListBox_Text := ""
Loop, Read, Apropos_util_history.txt
{
	ListBox_Text .= A_LoopReadLine "|" ;append a line of text
}
GuiControl,, MyListBox, |%ListBox_Text%
return


2GuiClose:
2GuiEscape:
	Gui, 2:Destroy
return

activenp:
	IfWinNotExist, Open Apropos File?
return  ; Keep waiting.
settimer, activenp, off
WinMove,Open Apropos File?,, %Xms%, %Yms%
WinSet, Transparent, 230, A
WinActivate, ahk_pid %NewPID% ahk_class Notepad++
return

firstnp:
	IfWinNotExist, Open Apropos File?
return  ; Keep waiting.
settimer, firstnp, off
WinMove,Open Apropos File?,, %Xmsf%, %Ymsf%
WinSet, Transparent, 255, A
return


msgpos:
	WinGetPos, Xms, Yms, , ,Open Apropos File?
return

Reallyopen:
	StringSplit, sfilearr, sentencefilearr3, ?
	Loop, %sfilearr0%
	{
		Xmsf:=100
	    Ymsf:=100
		settimer, firstnp, 10
		filefound=1;
		path := sfilearr%a_index%
		settimer, msgpos, 100
		MsgBox,4099,Open Apropos File?, Open match Number %a_index% of %sfilearr0% at %path%?
		IfMsgBox, Cancel
			{
			settimer, msgpos, off
			settimer, firstnp, off
			settimer, activenp, off
			break
			}
		IfMsgBox, No
			continue
		settimer, msgpos, off
		Xms:=100
	    Yms:=100
		settimer, activenp, 100
		Run, "%notepad_path%" %path%,,, NewPID
		RegExMatch(notepad_path, "([^\\]+$)", pathVar)

		Process, wait, %pathVar1%, 5.5
		NewPID = %ErrorLevel%  ; Save the value immediately since ErrorLevel is often changed.
		If NewPID = 0
		{
			MsgBox, The notepad process did not start, please Check path.
			return
		}
		sleep 600
		ClipSaved2 := ClipboardAll
		Clipboard = "%sentencefilearr2%"
		id := WinExist("A")
		IfWinExist, Reload
		{
			Send, {Right}
			Send, {Space}
			sleep 100
		}
		sleep 100
	Send, ^f
	sleep 300
	Send, ^v
	clipboard := ClipSaved2
	ClipSaved2 =
	sleep 20
	Send, !g
	sleep 10
	Send, {Enter}
	sleep 10
	Send, !n
	Send, {Escape}
	}
return

reload:
	Reload
return

tExit:
	ExitAPP
return

volumeup:
	if (voicevolume >10){
		voicevolume += 5
	}else{
		voicevolume += 2
	}
	settimer, dochange, off
	settimer, dochange, -400
return

volumedown:
	if (voicevolume >10){
		voicevolume -= 5
	}else{
		voicevolume -= 2
	}

	settimer, dochange, off
	settimer, dochange, -400

return

dochange:
	IniWrite, %voicevolume%, settings.ini, settings, voicevolume
	femVoiceVolume := voicevolume + femVoiceBoost
	maleVoiceVolume := voicevolume + maleVoiceBoost
	narVoiceVolume := voicevolume + narVoiceBoost
	;init voices
	femaleVoice := TTS_CreateVoice(femVoiceName, femVoiceRate, femVoiceVolume, femVoicePitch)
	maleVoice := TTS_CreateVoice(maleVoiceName, maleVoiceRate, maleVoiceVolume, maleVoicePitch)
	narVoice := TTS_CreateVoice(narVoiceName, narVoiceRate, narVoiceVolume, narVoicePitch)
	TTS(femaleVoice, "Stop")
	TTS(femaleVoice, "Speak", voicevolume)
return



TTS(oVoice, command, param1="", param2="") {		; by Learning one. For AHK_L. Thanks: jballi, Sean, Frankie.
		; AHK forum location:	www.autohotkey.com/forum/topic57773.html
		; Read more:			msdn.microsoft.com/en-us/library/ms723602(v=VS.85).aspx, www.autohotkey.com/forum/topic45471.html, www.autohotkey.com/forum/topic83162.html
		static CommandList := "ToggleSpeak,Speak,SpeakWait,Pause,Stop,SetRate,SetVolume,SetPitch,SetVoice,GetVoices,GetStatus,GetCount,SpeakToFile"
		If command not in %CommandList%
		{
			MsgBox, 16, TTS() Error, "%command%" is not valid command.
			return
		}
		If command = ToggleSpeak	; speak or stop speaking
		{
			Status := oVoice.Status.RunningState
			If Status = 1	; finished
				oVoice.Speak(param1,0x1)	; speak asynchronously
			Else If Status = 0	; Paused
			{
				oVoice.Resume
				oVoice.Speak("",0x1|0x2)	; stop
				oVoice.Speak(param1,0x1)	; speak asynchronously
			}
			Else If Status = 2	; Reading
				oVoice.Speak("",0x1|0x2)	; stop
		}
		Else If command = Speak		; speak asynchronously
		{
			Status := oVoice.Status.RunningState
			;if Status = 0	; paused
			;oVoice.Resume
			;oVoice.Speak("",0x1|0x2)	; stop
			oVoice.Speak(param1,1)	; speak asynchronously
		}
		Else If command = SpeakWait		; speak synchronously
		{
			Status := oVoice.Status.RunningState
			If Status = 0	; Paused
				oVoice.Resume
			oVoice.Speak("",0x1|0x2)	; stop
			oVoice.Speak(param1,0x0)	; speak synchronously
		}
		Else If command = Pause	; Pause Toggle
		{
			Status := oVoice.Status.RunningState
			If Status = 0	; Paused
				oVoice.Resume
			Else If Status = 2	; Reading
				oVoice.Pause
		}
		Else If command = Stop
		{
			Status := oVoice.Status.RunningState
			If Status = 0	; Paused
				oVoice.Resume
			oVoice.Speak("",0x1|0x2)	; stop
		}
		Else If command = SetRate
			oVoice.Rate := param1		; rate (Reading speed): param1 from -10 to 10. 0 is Default.
		Else If command = SetVolume
			oVoice.Volume := param1		; volume (Reading loudness): param1 from 0 to 100. 100 is Default
		Else If command = SetPitch				; http://msdn.microsoft.com/en-us/library/ms717077(v=vs.85).aspx
			oVoice.Speak("<pitch absmiddle = '" param1 "'/>",0x20)	; pitch : param1 from -10 to 10. 0 is Default.
		Else If command = SetVoice
		{
			Loop, % oVoice.GetVoices.Count
			{
				Name := oVoice.GetVoices.Item(A_Index-1).GetAttribute("Name")	; 0 based
				If (Name = param1)
				{
					DoesVoiceExist := 1
					break
				}
			}
			If !DoesVoiceExist
			{
				MsgBox,64,, Voice "%param1%" does not Exist.
				return
			}
			While !(oVoice.Status.RunningState = 1)
			Sleep, 20
			oVoice.Voice := oVoice.GetVoices("Name=" param1).Item(0) ; set voice to param1
		}
		Else If command = GetVoices
		{
			param1 := (param1 = "") ? "`n" : param1		; param1 as Delimiter
			Loop, % oVoice.GetVoices.Count
			{
				Name := oVoice.GetVoices.Item(A_Index-1).GetAttribute("Name")	; 0 based
				VoiceList .= Name param1
			}
			Return RTrim(VoiceList,param1)
		}
		Else If command = GetStatus
		{
			Status := oVoice.Status.RunningState
			If Status = 0 ; Paused
				Return "Paused"
			Else If Status = 1 ; finished
				Return "finished"
			Else If Status = 2 ; Reading
				Return "Reading"
		}
		Else If command = GetCount
			return oVoice.GetVoices.Count
		Else If command = SpeakToFile	; param1 = TextToSpeak,    param2 = OutputFilePath
		{
			oldAOS := oVoice.AudioOutputStream
			oldAAOFCONS := oVoice.AllowAudioOutputFormatChangesOnNextSet
			oVoice.AllowAudioOutputFormatChangesOnNextSet := 1

			SpStream := ComObjCreate("SAPI.SpFileStream")
			FileDelete, % param2	; OutputFilePath
			SpStream.Open(param2, 3)
			oVoice.AudioOutputStream := SpStream
			TTS(oVoice, "SpeakWait", param1)
			SpStream.Close()
			oVoice.AudioOutputStream := oldAOS
			oVoice.AllowAudioOutputFormatChangesOnNextSet := oldAAOFCONS
		}
	}

TTS_CreateVoice(VoiceName="", VoiceRate="", VoiceVolume="", VoicePitch="") {		; by Learning one. For AHK_L.
		oVoice := ComObjCreate("SAPI.SpVoice")
		If !(VoiceName = "")
			TTS(oVoice, "SetVoice", VoiceName)
		If VoiceRate Between -10 and 10
			oVoice.Rate := VoiceRate		; rate (Reading speed): from -10 to 10. 0 is Default.
		If VoiceVolume Between 0 and 100
			oVoice.Volume := VoiceVolume	; volume (Reading loudness): from 0 to 100. 100 is Default
		If VoicePitch Between -10 and 10
			TTS(oVoice, "SetPitch", VoicePitch)	; pitch: from -10 to 10. 0 is Default.
		return oVoice
	}